Index: /code/trunk/src/orxonox/core/Language.cc
===================================================================
--- /code/trunk/src/orxonox/core/Language.cc	(revision 870)
+++ /code/trunk/src/orxonox/core/Language.cc	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file Language.cc
     @brief Implementation of the Language and the LanguageEntry class.
@@ -50,22 +50,22 @@
 
         this->fallbackEntry_ = fallbackEntry;
-        this->translatedEntry_ = fallbackEntry; // Set the translation to the fallback entry, for the case that no translation gets assigned
-        this->bTranslationSet_ = false;
-    }
-
-    /**
-        @brief Sets the translation of the entry.
-        @param translation The translation
-    */
-    void LanguageEntry::setTranslation(const std::string& translation)
+        this->localisedEntry_ = fallbackEntry; // Set the localisation to the fallback entry, for the case that no translation gets assigned
+        this->bLocalisationSet_ = false;
+    }
+
+    /**
+        @brief Sets the localisation of the entry.
+        @param localisation The localisation
+    */
+    void LanguageEntry::setLocalisation(const std::string& localisation)
     {
         // Check if the translation is more than just an empty string
-        if (translation.compare("") != 0)
-        {
-            this->translatedEntry_ = translation;
-            this->bTranslationSet_ = true;
+        if (localisation.compare("") != 0)
+        {
+            this->localisedEntry_ = localisation;
+            this->bLocalisationSet_ = true;
         }
         else
-            this->translatedEntry_ = this->fallbackEntry_;
+            this->localisedEntry_ = this->fallbackEntry_;
     }
 
@@ -77,6 +77,6 @@
     {
         // If the default entry changes and the translation wasn't set yet, use the new default entry as translation
-        if (!this->bTranslationSet_)
-            this->translatedEntry_ = fallbackEntry;
+        if (!this->bLocalisationSet_)
+            this->localisedEntry_ = fallbackEntry;
 
         this->fallbackEntry_ = fallbackEntry;
@@ -94,5 +94,5 @@
 
         this->defaultLanguage_ = "default";
-        this->defaultTranslation_ = "ERROR: LANGUAGE ENTRY DOESN'T EXIST!";
+        this->defaultLocalisation_ = "ERROR: LANGUAGE ENTRY DOESN'T EXIST!";
 
         // Read the default language file to create all known LanguageEntry objects
@@ -132,12 +132,12 @@
 
     /**
-        @brief Creates a new LanguageEntry with a given name and a given default entry.
-        @param name The name of the entry
+        @brief Creates a new LanguageEntry with a given label and a given default entry.
+        @param label The label of the entry
         @param entry The default entry
         @return The created LanguageEntry object
     */
-    LanguageEntry* Language::createEntry(const LanguageEntryName& name, const std::string& entry)
-    {
-        std::map<std::string, LanguageEntry*>::const_iterator it = this->languageEntries_.find(name);
+    LanguageEntry* Language::createEntry(const LanguageEntryLabel& label, const std::string& entry)
+    {
+        std::map<std::string, LanguageEntry*>::const_iterator it = this->languageEntries_.find(label);
 
         // Make sure we don't create a duplicate entry
@@ -145,10 +145,10 @@
         {
             LanguageEntry* newEntry = new LanguageEntry(entry);
-            newEntry->setName(name);
-            this->languageEntries_[name] = newEntry;
+            newEntry->setLabel(label);
+            this->languageEntries_[label] = newEntry;
             return newEntry;
         }
 
-        COUT(2) << "Warning: Language entry " << name << " is duplicate in " << getFileName(this->defaultLanguage_) << "!" << std::endl;
+        COUT(2) << "Warning: Language entry " << label << " is duplicate in " << getFileName(this->defaultLanguage_) << "!" << std::endl;
         return it->second;
     }
@@ -156,15 +156,15 @@
     /**
         @brief Adds a new LanguageEntry, if it's not already existing.
-        @param name The name of the entry
+        @param label The label of the entry
         @param entry The default entry
     */
-    void Language::addEntry(const LanguageEntryName& name, const std::string& entry)
-    {
-        COUT(5) << "Called addEntry with\n  name: " << name << "\n  entry: " <<  entry << std::endl;
-        std::map<std::string, LanguageEntry*>::const_iterator it = this->languageEntries_.find(name);
+    void Language::addEntry(const LanguageEntryLabel& label, const std::string& entry)
+    {
+        COUT(5) << "Language: Called addEntry with\n  label: " << label << "\n  entry: " <<  entry << std::endl;
+        std::map<std::string, LanguageEntry*>::const_iterator it = this->languageEntries_.find(label);
         if (it == this->languageEntries_.end())
         {
             // The entry isn't available yet, meaning it's new, so create it
-            this->createEntry(name, entry);
+            this->createEntry(label, entry);
         }
         else if (it->second->getDefault().compare(entry) == 0)
@@ -185,18 +185,18 @@
 
     /**
-        @brief Returns the translation of a given entry.
-        @param name The name of the entry
-        @return The translation
-    */
-    const std::string& Language::getTranslation(const LanguageEntryName& name) const
-    {
-        std::map<std::string, LanguageEntry*>::const_iterator it = this->languageEntries_.find(name);
+        @brief Returns the localisation of a given entry.
+        @param label The label of the entry
+        @return The localisation
+    */
+    const std::string& Language::getLocalisation(const LanguageEntryLabel& label) const
+    {
+        std::map<std::string, LanguageEntry*>::const_iterator it = this->languageEntries_.find(label);
         if (it != this->languageEntries_.end())
-            return it->second->getTranslation();
+            return it->second->getLocalisation();
         else
         {
             // Uh, oh, an undefined entry was requested: return the default string
-            COUT(2) << "Error: Language entry \"" << name << "\" not found!" << std::endl;
-            return this->defaultTranslation_;
+            COUT(2) << "Warning: Language entry \"" << label << "\" not found!" << std::endl;
+            return this->defaultLocalisation_;
         }
     }
@@ -230,4 +230,5 @@
         if (!file.is_open())
         {
+            COUT(1) << "An error occurred in Language.cc:" << std::endl;
             COUT(1) << "Error: Couldn't open file " << getFileName(this->defaultLanguage_) << " to read the default language entries!" << std::endl;
             return;
@@ -259,5 +260,5 @@
 
     /**
-        @brief Reads the language file of the configured language and assigns the translations to the corresponding LanguageEntry object.
+        @brief Reads the language file of the configured language and assigns the localisation to the corresponding LanguageEntry object.
     */
     void Language::readTranslatedLanguageFile()
@@ -271,4 +272,5 @@
         if (!file.is_open())
         {
+            COUT(1) << "An error occurred in Language.cc:" << std::endl;
             COUT(1) << "Error: Couldn't open file " << getFileName(this->language_) << " to read the translated language entries!" << std::endl;
             ResetConfigValue(language_);
@@ -297,7 +299,7 @@
                     // Check if the entry exists
                     if (it != this->languageEntries_.end())
-                        it->second->setTranslation(lineString.substr(pos + 1));
+                        it->second->setLocalisation(lineString.substr(pos + 1));
                     else
-                        this->createEntry(lineString.substr(0, pos), this->defaultTranslation_)->setTranslation(lineString.substr(pos + 1));
+                        this->createEntry(lineString.substr(0, pos), this->defaultLocalisation_)->setLocalisation(lineString.substr(pos + 1));
                 }
                 else
@@ -314,5 +316,5 @@
     void Language::writeDefaultLanguageFile() const
     {
-        COUT(4) << "Write default language file." << std::endl;
+        COUT(4) << "Language: Write default language file." << std::endl;
 
         // Open the file
@@ -322,4 +324,5 @@
         if (!file.is_open())
         {
+            COUT(1) << "An error occurred in Language.cc:" << std::endl;
             COUT(1) << "Error: Couldn't open file " << getFileName(this->defaultLanguage_) << " to write the default language entries!" << std::endl;
             return;
@@ -329,5 +332,5 @@
         for (Iterator<LanguageEntry> it = ObjectList<LanguageEntry>::start(); it; ++it)
         {
-            file << it->getName() << "=" << it->getDefault() << std::endl;
+            file << it->getLabel() << "=" << it->getDefault() << std::endl;
         }
 
Index: /code/trunk/src/orxonox/core/Language.h
===================================================================
--- /code/trunk/src/orxonox/core/Language.h	(revision 870)
+++ /code/trunk/src/orxonox/core/Language.h	(revision 871)
@@ -26,18 +26,18 @@
  */
 
-/*!
+/**
     @file Language.h
     @brief Definition of the Language and the LanguageEntry class.
 
-    The Language class is used, to get a translation of a string in the configured language.
-    The string is identified by another string, the name of the entry.
+    The Language class is used, to get a localisation of a string in the configured language.
+    The string is identified by another string, the label of the entry.
     If the translation in the configured language isn't available, the default entry, defined in the code, is used.
 
     Usage:
      - Set the entry with the default string:
-       Language::getLanguage()->addEntry("name of the entry", "the string to translate");
+       Language::getLanguage()->addEntry("label of the entry", "the string to translate");
 
-     - Get the translation of the entry in the configured language:
-       std::cout << Language::getLanguage()->getTranslation("name of the entry") << std::endl;
+     - Get the localisation of the entry in the configured language:
+       std::cout << Language::getLanguage()->getLocalisation("name of the entry") << std::endl;
 */
 
@@ -51,8 +51,17 @@
 #include "OrxonoxClass.h"
 
+
+#define AddLanguageEntry(label, fallbackstring) \
+    orxonox::Language::getLanguage().addEntry(label, fallbackstring)
+
+#define GetLocalisation(label) \
+    orxonox::Language::getLanguage().getLocalisation(label)
+
+
 namespace orxonox
 {
-    typedef std::string LanguageEntryName;
-
+    // ###############################
+    // ###      LanguageEntry      ###
+    // ###############################
     //! The LanguageEntry class stores the default- and the translated string of a given entry in the language file.
     class _CoreExport LanguageEntry : public OrxonoxClass
@@ -60,13 +69,13 @@
         public:
             explicit LanguageEntry(const std::string& fallbackEntry);
-            void setTranslation(const std::string& translation);
+            void setLocalisation(const std::string& localisation);
             void setDefault(const std::string& fallbackEntry);
 
             /**
-              @brief Returns the translated entry in the configured language.
+              @brief Returns the localised entry in the configured language.
               @return The translated entry
             */
-            inline const std::string& getTranslation()
-                { return this->translatedEntry_; }
+            inline const std::string& getLocalisation()
+                { return this->localisedEntry_; }
 
             /**
@@ -77,12 +86,29 @@
                 { return this->fallbackEntry_; }
 
+            /**
+                @brief Sets the label of this entry.
+                @param label The label
+            */
+            inline void setLabel(const LanguageEntryLabel& label)
+                { this->label_ = label; }
+
+            /**
+                @brief Returns the label of this entry.
+                @return The label
+            */
+            inline const LanguageEntryLabel& getLabel() const
+                { return this->label_; }
+
         private:
-            std::string fallbackEntry_;                             //!< The default entry: Used, if no translation is available or no language configured
-            std::string translatedEntry_;                           //!< The translated entry in the configured language
-            bool bTranslationSet_;                                  //!< True if the translation was set
+            LanguageEntryLabel label_;              //!< The label of the entry
+            std::string fallbackEntry_;             //!< The default entry: Used, if no translation is available or no language configured
+            std::string localisedEntry_;            //!< The localised entry in the configured language
+            bool bLocalisationSet_;                 //!< True if the translation was set
     };
-    template class _CoreExport orxonox::ClassIdentifier<LanguageEntry>;
-    template class _CoreExport orxonox::ObjectList<LanguageEntry>;
 
+
+    // ###############################
+    // ###         Language        ###
+    // ###############################
     //! The Language class manges the language files and entries and stores the LanguageEntry objects in a map.
     class _CoreExport Language : public OrxonoxClass
@@ -94,6 +120,6 @@
             static Language& getLanguage();
             void setConfigValues();
-            void addEntry(const LanguageEntryName& name, const std::string& entry);
-            const std::string& getTranslation(const LanguageEntryName& name) const;
+            void addEntry(const LanguageEntryLabel& label, const std::string& entry);
+            const std::string& getLocalisation(const LanguageEntryLabel& label) const;
 
         private:
@@ -106,13 +132,11 @@
             void writeDefaultLanguageFile() const;
             static const std::string getFileName(const std::string& language);
-            LanguageEntry* createEntry(const LanguageEntryName& name, const std::string& entry);
+            LanguageEntry* createEntry(const LanguageEntryLabel& label, const std::string& entry);
 
             std::string language_;                                  //!< The configured language
             std::string defaultLanguage_;                           //!< The default language
-            std::string defaultTranslation_;                        //!< The returned string, if an entry unavailable entry is requested
-            std::map<std::string, LanguageEntry*> languageEntries_; //!< A map to store all LanguageEntry objects and their name
+            std::string defaultLocalisation_;                       //!< The returned string, if an entry unavailable entry is requested
+            std::map<std::string, LanguageEntry*> languageEntries_; //!< A map to store all LanguageEntry objects and their labels
     };
-    template class _CoreExport orxonox::ClassIdentifier<Language>;
-    template class _CoreExport orxonox::ObjectList<Language>;
 }
 
Index: /code/trunk/src/orxonox/core/Level.h
===================================================================
--- /code/trunk/src/orxonox/core/Level.h	(revision 871)
+++ /code/trunk/src/orxonox/core/Level.h	(revision 871)
@@ -0,0 +1,53 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _Level_H__
+#define _Level_H__
+
+#include <string>
+
+#include "CorePrereqs.h"
+#include "ClassTreeMask.h"
+
+namespace orxonox
+{
+    class _CoreExport Level
+    {
+        public:
+            Level(const std::string& file) : file_(file) {}
+            Level(const std::string& file, const ClassTreeMask& mask) : file_(file), mask_(mask) {};
+
+            const std::string& getFile() const { return this->file_; }
+            const ClassTreeMask& getMask() const { return this->mask_; }
+
+        private:
+            std::string file_;
+            ClassTreeMask mask_;
+    };
+}
+
+#endif /* _Level_H__ */
Index: /code/trunk/src/orxonox/core/Loader.cc
===================================================================
--- /code/trunk/src/orxonox/core/Loader.cc	(revision 871)
+++ /code/trunk/src/orxonox/core/Loader.cc	(revision 871)
@@ -0,0 +1,168 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "Loader.h"
+#include "Level.h"
+#include "BaseObject.h"
+#include "Identifier.h"
+#include "Iterator.h"
+#include "Debug.h"
+#include "CoreIncludes.h"
+
+#include "util/tinyxml/ticpp.h"
+
+namespace orxonox
+{
+    std::vector<std::pair<const Level*, ClassTreeMask> > Loader::levels_s;
+    ClassTreeMask Loader::currentMask_s;
+
+    bool Loader::open(const Level* level, const ClassTreeMask& mask)
+    {
+        Loader::add(level, mask);
+        return Loader::load(level, mask);
+    }
+
+    void Loader::close()
+    {
+        Loader::unload();
+        Loader::levels_s.clear();
+    }
+
+    void Loader::close(const Level* level)
+    {
+        Loader::unload(level);
+        Loader::remove(level);
+    }
+
+    void Loader::add(const Level* level, const ClassTreeMask& mask)
+    {
+        Loader::levels_s.insert(Loader::levels_s.end(), std::pair<const Level*, ClassTreeMask>(level, mask));
+    }
+
+    void Loader::remove(const Level* level)
+    {
+        for (std::vector<std::pair<const Level*, ClassTreeMask> >::iterator it = Loader::levels_s.begin(); it != Loader::levels_s.end(); ++it)
+        {
+            if ((*it).first == level)
+            {
+                Loader::levels_s.erase(it);
+                break;
+            }
+        }
+    }
+
+    bool Loader::load(const ClassTreeMask& mask)
+    {
+        bool success = true;
+        for (std::vector<std::pair<const Level*, ClassTreeMask> >::iterator it = Loader::levels_s.begin(); it != Loader::levels_s.end(); ++it)
+            if (!Loader::load((*it).first, (*it).second * mask))
+                success = false;
+
+        return success;
+    }
+
+    void Loader::unload(const ClassTreeMask& mask)
+    {
+        for (Iterator<BaseObject> it = ObjectList<BaseObject>::begin(); it; )
+        {
+            if (mask.isIncluded(it->getIdentifier()))
+                delete (*(it++));
+            else
+                ++it;
+        }
+    }
+
+    bool Loader::reload(const ClassTreeMask& mask)
+    {
+        Loader::unload(mask);
+        return Loader::load(mask);
+    }
+
+    bool Loader::load(const Level* level, const ClassTreeMask& mask)
+    {
+        Loader::currentMask_s = level->getMask() * mask;
+
+        try
+        {
+            COUT(0) << "Start loading " << level->getFile() << "..." << std::endl;
+            COUT(3) << "Mask: " << Loader::currentMask_s << std::endl;
+
+            ticpp::Document xmlfile(level->getFile());
+            xmlfile.LoadFile();
+
+            for ( ticpp::Iterator<ticpp::Element> child = xmlfile.FirstChildElement(false); child != child.end(); child++ )
+            {
+                Identifier* identifier = ID(child->Value());
+                if (identifier)
+                {
+                    if (Loader::currentMask_s.isIncluded(identifier))
+                    {
+                        COUT(4) << "  fabricating " << child->Value() << "..." << std::endl;
+                        BaseObject* newObject = identifier->fabricate();
+                        newObject->setLoaderIndentation("    ");
+                        newObject->setLevel(level);
+                        newObject->XMLPort(*child, true);
+                        COUT(5) << "  ...fabricated " << child->Value() << " (objectname " << newObject->getName() << ")." << std::endl;
+                    }
+                }
+                else
+                {
+                    COUT(2) << "  Warning: '" << child->Value() << "' is not a valid classname." << std::endl;
+                }
+            }
+
+            COUT(0) << "Finished loading " << level->getFile() << "." << std::endl;
+
+            return true;
+        }
+        catch(ticpp::Exception& ex)
+        {
+            COUT(1) << std::endl;
+            COUT(1) << "An error occurred in Loader.cc while loading " << level->getFile() << ":" << std::endl;
+            COUT(1) << ex.what() << std::endl;
+            COUT(1) << "Loading aborted." << std::endl;
+            return false;
+        }
+    }
+
+    void Loader::unload(const Level* level, const ClassTreeMask& mask)
+    {
+        for (Iterator<BaseObject> it = ObjectList<BaseObject>::begin(); it; )
+        {
+            if ((it->getLevel() == level) && mask.isIncluded(it->getIdentifier()))
+                delete (*(it++));
+            else
+                ++it;
+        }
+    }
+
+    bool Loader::reload(const Level* level, const ClassTreeMask& mask)
+    {
+        Loader::unload(level, mask);
+        return Loader::load(level, mask);
+    }
+}
Index: /code/trunk/src/orxonox/core/Loader.h
===================================================================
--- /code/trunk/src/orxonox/core/Loader.h	(revision 871)
+++ /code/trunk/src/orxonox/core/Loader.h	(revision 871)
@@ -0,0 +1,65 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _Loader_H__
+#define _Loader_H__
+
+#include <vector>
+
+#include "ClassTreeMask.h"
+#include "Level.h"
+
+#include "CorePrereqs.h"
+
+namespace orxonox
+{
+    class _CoreExport Loader
+    {
+        public:
+            static bool open(const Level* level, const ClassTreeMask& mask = ClassTreeMask());
+            static void close();
+            static void close(const Level* level);
+
+            static void add(const Level* level, const ClassTreeMask& mask = ClassTreeMask());
+            static void remove(const Level* level);
+
+            static bool load(const ClassTreeMask& mask = ClassTreeMask());
+            static void unload(const ClassTreeMask& mask = ClassTreeMask());
+            static bool reload(const ClassTreeMask& mask = ClassTreeMask());
+
+            static bool load(const Level* level, const ClassTreeMask& mask = ClassTreeMask());
+            static void unload(const Level* level, const ClassTreeMask& mask = ClassTreeMask());
+            static bool reload(const Level* level, const ClassTreeMask& mask = ClassTreeMask());
+
+            static ClassTreeMask currentMask_s;
+
+        private:
+            static std::vector<std::pair<const Level*, ClassTreeMask> > levels_s;
+    };
+}
+
+#endif /* _Loader_H__ */
Index: /code/trunk/src/orxonox/core/MetaObjectList.cc
===================================================================
--- /code/trunk/src/orxonox/core/MetaObjectList.cc	(revision 870)
+++ /code/trunk/src/orxonox/core/MetaObjectList.cc	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file MetaObjectList.cc
     @brief Implementation of the MetaObjectList class.
Index: /code/trunk/src/orxonox/core/MetaObjectList.h
===================================================================
--- /code/trunk/src/orxonox/core/MetaObjectList.h	(revision 870)
+++ /code/trunk/src/orxonox/core/MetaObjectList.h	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file MetaObjectList.h
     @brief Definition of the MetaObjectList class.
@@ -99,5 +99,5 @@
 
 
-        COUT(4) << "*** Removing Object from " << ClassIdentifier<T>::getIdentifier()->getName() << "-list." << std::endl;
+        COUT(5) << "*** MetaObjectList: Removing Object from " << this->element_->object_->getIdentifier()->getName() << "-list." << std::endl;
         delete this->element_;
     }
Index: /code/trunk/src/orxonox/core/ObjectList.h
===================================================================
--- /code/trunk/src/orxonox/core/ObjectList.h	(revision 870)
+++ /code/trunk/src/orxonox/core/ObjectList.h	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file ObjectList.h
     @brief Definition and implementation of the ObjectList class.
@@ -40,4 +40,5 @@
 #include "CorePrereqs.h"
 #include "Iterator.h"
+#include "ClassManager.h"
 
 namespace orxonox
@@ -83,27 +84,24 @@
     {
         public:
-            static ObjectList<T>* getList();
+            ObjectList();
+            ~ObjectList();
 
             ObjectListElement<T>* add(T* object);
 //            void remove(OrxonoxClass* object, bool bIterateForwards = true);
 
-            /** @returns the first element in the list */
+            /** @brief Returns the first element in the list. @return The first element */
             inline static Iterator<T> start()
-                { return Iterator<T>(getList()->first_); }
-
-            /** @returns the first element in the list */
+                { return Iterator<T>(ClassManager<T>::getIdentifier()->getObjects()->first_); }
+
+            /** @brief Returns the first element in the list. @return The first element */
             inline static Iterator<T> begin()
-                { return Iterator<T>(getList()->first_); }
-
-            /** @returns the last element in the list */
+                { return Iterator<T>(ClassManager<T>::getIdentifier()->getObjects()->first_); }
+
+            /** @brief Returns the last element in the list. @return The last element */
             inline static Iterator<T> end()
-                { return Iterator<T>(getList()->last_); }
+                { return Iterator<T>(ClassManager<T>::getIdentifier()->getObjects()->last_); }
 
             ObjectListElement<T>* first_;       //!< The first element in the list
             ObjectListElement<T>* last_;        //!< The last element in the list
-
-        private:
-            ObjectList();
-            ~ObjectList();
     };
 
@@ -131,14 +129,4 @@
             this->first_ = temp;
         }
-    }
-
-    /**
-        @returns a pointer to the only existing instance for the given class T.
-    */
-    template <class T>
-    ObjectList<T>* ObjectList<T>::getList()
-    {
-        static ObjectList<T> theOnlyObjectListObjectForClassT = ObjectList<T>();
-        return &theOnlyObjectListObjectForClassT;
     }
 
Index: /code/trunk/src/orxonox/core/OrxonoxClass.cc
===================================================================
--- /code/trunk/src/orxonox/core/OrxonoxClass.cc	(revision 870)
+++ /code/trunk/src/orxonox/core/OrxonoxClass.cc	(revision 871)
@@ -26,5 +26,5 @@
  */
 
-/*!
+/**
     @file OrxonoxClass.cc
     @brief Implementation of the OrxonoxClass Class.
@@ -42,7 +42,4 @@
         this->identifier_ = 0;
         this->parents_ = 0;
-
-        this->bActive_ = true;
-        this->bVisible_ = true;
     }
 
